package com.example;

import com.example.commands.ExampleCommand;
import com.example.modules.ExampleModule;
import com.mojang.logging.LogUtils;
import dev.shrecked.components.Command;
import dev.shrecked.components.Module;
import dev.shrecked.components.ModuleRegistry;
import dev.shrecked.components.SunAddonInitializer;
import org.slf4j.Logger;

import java.lang.invoke.MethodHandles;
import java.util.List;

public class ExampleAddon implements SunAddonInitializer {
    public static final Logger LOGGER = LogUtils.getLogger();

	@Override
	public void onInitialize() {
		ModuleRegistry.NORBIT.registerLambdaFactory("com.example", (lookupInMethod, klass) -> (MethodHandles.Lookup) lookupInMethod.invoke(null, klass, MethodHandles.lookup()));
		LOGGER.info("Sun example addon initialized!");
	}

	@Override
	public List<Module> loadModules() {
		return List.of(new Module[]{
				new ExampleModule()
		});
	}

	@Override
	public List<Command> loadCommands() {
		return List.of(new Command[]{
				new ExampleCommand()
		});
	}
}